\ Serial i/o drivers for Z80/64180 + CPM

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release:	May 1991

Changes:	See RELEASE.DOC for full details
))
\ CPM driver

only forth definitions

: init-ser	\ -- ; initialise
  ;

hex

code (emit)	\ char --
  exx   de pop   c, # 6 ld
  ix push   iy push   5 call  iy pop   ix pop   \ call BDOS
  exx   next,
end-code

: emit		\ char --
  (emit)  1 out +!  ;

: type		\ addr len --
  bounds ?do  i c@ emit  loop  ;

: cr		\ --
  0A emit   0D emit   out off  ;

code (key)      \ -- char ; read character from terminal
l: char-ip
  exx
l: pkey-loop
  c, # 6 ld   e, # 0FF ld
  ix push   iy push   5 call  iy pop   ix pop   \ call BDOS
  a, a or   z, pkey-loop jr
  l, a ld   h, # 0 ld   hl push
  exx   next,
end-code

defer key       \ -- char ; reads character from channel
  assign (key) to-do key                \ default to serial

code (key?)     \ -- t/f ; true if character available
  exx   c, # 0B ld
  ix push   iy push   5 call  iy pop   ix pop   \ call BDOS
  l, a ld   h, a ld   hl push
  exx   next,
end-code

: key?          \ -- t/f ; true if character available
  (key?)  ;


\ all done

decimal

;p
