\ Special function register equates for 64180
pto	

Copyright (C) 1994

MicroProcessor Engineering Ltd
133 Hill Lane 
Southampton
UK
SO41 5AF

tel +44 703 631441
fax +44 703 339691
email mpe@cix.compulink.co.uk

For the correct usage or these equates you should refer
to the 64180 user manual.

\ these equates refer to the I/O address space

hex

000 equ CNTLA0		\ ASCI control register A channel 0
001 equ CNTLA1		\ ASCI control register A channel 1
002 equ CNTLB0		\ ASCI control register B channel 0
003 equ CNTLB1		\ ASCI control register B channel 1
004 equ STAT0		\ ASCI status register channel 0
005 equ STAT1		\ ASCI status register channel 1
006 equ TDR0		\ ASCI transmit data register channel 0
007 equ TDR1		\ ASCI transmit data register channel 1
008 equ TSR0		\ ASCI receive data register channel 0
009 equ TSR1		\ ASCI receive data register channel 1

00A equ CNTR		\ CSI/O control register							     
00B equ TRDR		\ CSI/O transmit/receive data register

00C equ TMDR0L		\ Timer data register channel 0L
00D equ TMDR0H		\ Timer data register channel 0H
00E equ RLDR0L		\ Timer reload register channel 0L
00F equ RLDR0H		\ Timer reload register channel 0H
010 equ TCR		\ Timer control register	     
014 equ TMDR1L		\ Timer data register channel 1L
015 equ TMDR1H		\ Timer data register channel 1H  
016 equ RLDR1L		\ Timer reload register channel 1L
017 equ RLDR1H		\ Timer reload register channel 1H

018 equ FRC		\ Free running counter

020 equ SAR0L		\ DMA source address register channel 0L
021 equ SAR0H		\ DMA source address register channel 0H
022 equ SAR0B		\ DMA source address register channel 0B
023 equ DAR0L		\ DMA destination address register channel 0L
024 equ DAR0H		\ DMA destination address register channel 0H
025 equ DAR0B		\ DMA destination address register channel 0B
026 equ BCR0L		\ DMA byte count register channel 0L
027 equ BCR0H		\ DMA byte count register channel 0H
028 equ MAR1L		\ DMA memory address register channel 1L
029 equ MAR1H		\ DMA memory address register channel 1H
02A equ MAR1B		\ DMA memory address register channel 1B
02B equ IAR1L		\ DMA I/O address register channel 1L
02C equ IAR1H		\ DMA I/O address register channel 1H
02E equ BCR1L		\ DMA byte count register channel 1L
02F equ BCR1H		\ DMA byte count register channel 1H
030 equ DSTAT		\ DMA status register
031 equ DMODE		\ DMA mode register
032 equ DCNTL		\ DMA/WAIT control register

033 equ IL		\ Interrupt vector low register
034 equ ITC		\ INT/TRAP control register

036 equ RCR		\ refresh control register

038 equ CBR		\ MMU common base register
039 equ BBR		\ MMU bank base register
03A equ CBAR		\ MMU common/bank area register

03F equ ICR		\ I/O control register


