\ colour support for xshell3


\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  colour-setting vars

variable title-attrib			\ colour of screen title
  112 title-attrib !
variable help-prompt-attrib		\ colour of help prompt on top line
  112 help-prompt-attrib !
variable body-attrib			\ colour of body of screen
  7 body-attrib !
variable header-attrib			\ colour of window header
  12 header-attrib !
variable border-attrib			\ colour of window border
  14 border-attrib !
variable window-attrib public		\ colour of body of window
  7 window-attrib !
variable help-border-attrib		\ border/header of context-help window
  12 help-border-attrib !
variable help-body-attrib		\ body of context-help window
  7 help-body-attrib !

variable temp-title-attrib		\ temp versions of above, for colour setting window
variable temp-help-prompt-attrib	
variable temp-body-attrib		
variable temp-header-attrib		
variable temp-border-attrib		
variable temp-window-attrib		
variable temp-help-border-attrib	
variable temp-help-body-attrib	

\ -----End of Page-----
\ -- R.G.G -- 26/9/90 --  set-attribs

: >attribs   		\ n -- ; set this colour
  1 screen-2drop
;

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  colours

hex

: yellow		\ -- ; yellow text on ??? background
  window-attrib @ 00e or 0fe and >attribs
; public  

: attrib>7              \ -- ; set screen body attribute
  body-attrib @ >attribs
; public                                                              

: dark			\ -- ; set window body attribute
  window-attrib @ >attribs
; public
                                                               
: attrib>112            \ -- ; set colour for top bar
  title-attrib @ >attribs
;                                                               

: attrib>116            \ -- ; set colour for help prompt on top line
  help-prompt-attrib @ >attribs
;                                                                

: red			\ -- ; set red text on ??? background
  0 screen-drop
  00c or 0fc and >attribs
; public
