\ Floating point 

only forth also c-c definitions

\ 02/10/91

code f!         \ fn addr --
  0 [bx] pop   2 [bx] pop   4 [bx] pop
  bx pop   next,   end-code

code f@         \ addr -- fn
  4 [bx] push   2 [bx] push   bx, 0 [bx] mov
  next,   end-code

code fdup       \ fn -- fn fn
  cx pop  dx pop
  dx push  cx push  bx push
  dx push  cx push   next,   end-code


\ fover                                            sfp 20/11/89

decimal

code fover      \ f1 f2 -- f1 f2 f1
  bx push   bx, sp mov
  ss: 10 [bx] push   ss: 8 [bx] push   ss: bx, 6 [bx] mov
  next,   end-code



\ ftemp frot                                        \  21/11/89
decimal

create ftemp  18 allot  \ -- addr ; three item buffer
  ftemp 18 erase

code frot       \ f1 f2 f3 -- f2 f3 f1
  ftemp bx mov   bx, # ftemp mov
  2 [bx] pop  4 [bx] pop                \ f3 to buffer
  6 [bx] pop  8 [bx] pop  10 [bx] pop   \ f2 to buffer
  ax pop   cx pop   dx pop              \ f1 to registers
  10 [bx] push  8 [bx] push  6 [bx] push  \ push f2
  4 [bx] push  2 [bx] push  0 [bx] push   \ push f3
  dx push  cx push  bx, ax mov            \ push f1
  next,   end-code

\ fswap fdrop                                      sfp 20/11/89

code fswap      \ f1 f2 -- f2 f1
  ftemp bx mov   bx, # ftemp mov
  2 [bx] pop   4 [bx] pop               \ f2 to buffer
  ax pop   cx pop   dx pop              \ f1 to registers
  4 [bx] push  2 [bx] push  0 [bx] push \ push f2
  dx push   cx push   bx, ax mov        \ push f1
  next,   end-code

code fdrop      \ f1 --
  sp, # 4 add   bx pop   next,   end-code



\ 8086 shift routines .............................sfp 20/11/89

CODE <-S        \ d1 carry-in-flag --- d2 carry-out-flag
  bp, sp xchg   bx, # 1 rcr
  2 [bp], # 1 rcl   0 [bp], # 1 rcl
  bx, bx xor   bx, # 1 rcl
  bp, sp xchg   next,   END-CODE

CODE S->        \ d1 carry-in-flag --- d2 carry-out-flag
  bp, sp xchg   bx, # 1 rcr
  0 [bp], # 1 rcr   2 [bp], # 1 rcr
  bx, bx xor   bx, # 1 rcl
  bp, sp xchg   next,   END-CODE



\ 8086 shift routines .............................sfp 07/04/90

code d<<1       ( d1 -- d2 )
  AX POP   AX, # 1 SAL   BX, # 1 RCL
  AX PUSH   next,   END-CODE

CODE d>>1       ( d1 -- d2 )
  AX POP   BX, # 1 SHR   AX, # 1 RCR
  AX PUSH   next,   END-CODE

code q<<1       ( q1 -- q2 )
  bp, sp xchg
  4 [bp], # 1 sal   2 [bp], # 1 rcl
  0 [bp], # 1 rcl   bx, # 1 rcl
  bp, sp xchg   next,   end-code

