\ host mode code for xs3


\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  curr-dir words: culled from oldest PLD programmer

hex                                                             

code ?current-dir	\ drive# addr -- status ; get this dir. name
  cx, si mov   si, bx mov                                  
  ah, # 47 mov   dx pop   21 int                            
  si, cx mov   bx pop                                      
  next,
end-code                                         
                                                                
code ?drive		\ -- drive# ; get this drive number
  bx push                                                 
  ah, # 19 mov                                            
  21 int                                                  
  ah, ah sub                                              
  bx, ax mov                                              
  next,
end-code                                         

decimal 

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  attribs words

headers

: .prog			\ -- ; print the name of the system anywhere
  prog-name count type
;  

: .xshell               \ -- ; print the name on the  top banner
  space				\ in from edge
  .prog				\ and print name
;                                                               

decimal                                                                

: .f1                   \ -- ; print the help prompt
  50 screen-drop dup		 	\ -- type type
  2 mod 0=			 	\ -- type t/f-even
  [ hex ] 082 [ decimal ] =	 	\ -- InColor c/e/vga-colour
  or				 	\ -- colour?
  if attrib>116  endif		 	\ use red on white      
  ." F1 for Help "			\ print it anyway       
  attrib>7				\ back to normal        
;					\ mono: uses inverse    

headerless

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 -- .cur-dir
                                                                
: .$cur-dir		\ -- ; display current directory      
  0 pad 3 + ?current-dir      	\ drive# addr -- status         
  ?drive ascii A + pad c!	\ form current drive letter     
  ascii : pad 1+ c!                               
  ascii \ pad 2+ c!		\ now have d:\                  
  pad asciiz>$			\ finish off string             
  count                                                         
  dup here c!			\ store length                  
  here 1+ swap cmove		\ move string to line-buff      
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  top-bar-host

decimal                                                         

headers

: top-bar-host		\ -- ; print the top bar
  0 0 gotoxy			\ top of screen                 
  attrib>112			\ inverse attribs               
  .XSHELL			\ what program                  
  23 spaces			\ white space                   
  ." HOST MODE"			\ the mode                      
  24 spaces			\ space till end of line        
  .F1				\ the help key                  
  attrib>7			\ normal attribs                
;                                                               

headerless

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  add-.scr

: add-.scr		\ -- ; add the screen file to the line buffer
  screen-pcb 2+			\ current screen fil            
  61 0				\ for the characters in a PCB   
  do
    dup i + c@ upc		\ get char                      
    dup 0<>			\ if non-zero                   
    if
      1 here c+!		\ increment count               
      here c@ here + c!		\ store in line-buff   
    else
      drop
    endif                                            
  loop                                                          
  drop                                                          
;                                                               

\ -----End of Page-----
\ -- R.G.G -- 8/1/92 --  .files

headers                                                                

: add-.fth		\ -- $addr ; add .fth to line buffer
  curr-text$ cs> line-buff curr-text$ c@l 1+ cmovel	\ copy filename to this seg.
  line-buff text-name set-pathname		\ make dummy pcb
  "" .FTH" text-name set-ext			\ add extension
  text-name 2+ asciiz>$				\ convert back to string
;

: .files                \ -- ; print both file names and the directory
  0 line-buff c! 25 #rows @ gotoxy	\ start of line            
  .$cur-dir				\ add current directory         
  "" , " here $+			\ add a comma                   
  add-.scr				\ add screen file               
  "" , " here $+			\ add a comma                   
  add-.fth				\ add extension to text name
  here $+				\ add text file                 
  here 1+ here c@ 53 min type		\ show up to 58 chars  
;                                                               

behead

\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  bottom-bar-host

headers

: bottom-bar-host	\ -- ; print the bottom bar in host mode
  0 #rows @ gotoxy		\ bottom of screen              
  attrib>112			\ inverse attribs               
  1 5 screen-2drop
  80 spaces			\ blank the line
  0 5 screen-2drop
  .files			\ current files, etc            
  attrib>7			\ normal attribs                
;                                                               

headerless
  
\ -----End of Page-----
\ -- R.G.G -- 24/05/90 --  host

headers

: host			\ -- ; set up screen for host mode
  top-bar-host				\ top line of screen
  bottom-bar-host			\ bottom line of screen
  create-host-window			\ create the window
  host-handle @ open-window drop	\ open window
  host-handle @ op-handle !		\ redirect i/o
;

behead
