((

	SYM-DATA.FTH

	J Lee :- 22/6/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	Symbol data structures.

))




only Forth also c-c definitions



\ Constant/Variable structure offsets .. Jon 05/01/89
\

  3 cell(s)* offset c/v+                 \ From Target-Cfa-Field
 -3 cell(s)* offset c/v-                 \ To Target-Cfa-Field




\ Voc-Symbol structure offsets .. Jon 05/01/89
\

decimal
                                      \ all offsets go from
                                      \ Target-Cfa-Field

 -1 cell* offset status+				\ status field for symbol
  3 cell* offset t-nfa+					\ threads in target
#threads(t) cell* t-nfa+ offset t-vp+		\ where target is
  1 cell* t-vp+ offset <Voc-link(s)+		\ backward 32-bit pointer
  2 cell* <Voc-Link(s)+ offset >Voc-link(s)+	\ forward 32-bit pointer
  2 cell* >voc-link(s)+ offset Voc-Chunk+	\ segment for vocabulary





\ Voc-Symbol structure offsets .. Jon 05/01/89
\

decimal
                                      \ all offsets go to
                                      \ Target-Cfa-Field
  1 cell* offset status-				\
 -3 cell* offset t-nfa-					\ threads in target
#threads(t) negate cell* t-nfa- offset t-vp-	\ where target is
 -1 cell* t-vp- offset <Voc-link(s)-		\ backward 32-bit pointer
 -2 cell* <Voc-Link(s)- offset >Voc-link(s)-	\ forward 32-bit pointer
 -2 cell* >Voc-Link(s)- offset Voc-Chunk-	\ segment for vocabulary




\ Status word bits .. Jon 27/07/88
\

decimal

  1 Constant Resolved-Bit             \ These are flags that
  2 Constant Voc-Bit                  \ are 1 bit-field wide.
  4 Constant C/V-Bit                  \
  8 Constant Def-Word-Bit             \ Used in the status word
 16 Constant Immediate-Bit            \ of a symbol.
 32 Constant Smudge-Bit               \
 64 Constant Run-Time-Bit             \





\ Run-Time? Resolved? Voc? C/V? Def-Word? .. Jon 01/08/88
\


: Run-Time?	(( Symbol-Addr(d) -- t/f ))
  status+ @(s)l Run-Time-Bit and 0<>  ;


: Resolved?	(( Symbol-addr(d) -- t/f ))
  status+ @(s)l Resolved-Bit and 0<>  ;


: Voc?	(( Symbol-addr(d) -- t/f ))
  status+ @(s)l Voc-Bit and 0<>  ;


: C/V?	(( Symbol-addr(d) -- t/f ))
  status+ @(s)l C/V-Bit and 0<>  ;


: Def-Word?	(( Symbol-addr(d) -- t/f ))
  status+ @(s)l Def-Word-Bit and 0<>  ;











