\ test code for command line stuff

\ pto

\ compile with DOS command line:

\ MF3 ALL FROM-FILE TEST

\ where this file is called TEST.FTH

\ -----End of Page-----
\ -- R.G.G -- 18/3/92 --  switches

vocabulary commands				\ for the switches

only forth also commands definitions		\ define some

: /s			\ -- ; dummy switch
  cr ." slash s found"				\ just say this
;

: /t			\ -- ; dummy switch
  cr ." slash t found"				\ just say this
;

only forth definitions				\ back to the app itself

\ -----End of Page-----
\ -- R.G.G -- 18/3/92 --  command line processor

: process		\ addr -- ; process this switch
  ['] commands v-find				\ look for it
  if
    execute					\ do it if found
  else
    drop					\ ignore $addr
    cr ." invalid command"			\ say not found
  endif
;

: switches		\ -- ; process commands
  begin					\ loop until all switches gone
    bl word				\ get the string
    dup count upper			\ make upper case
    dup c@ 0<>				\ test if not null
   while				\ while not null
    process				\ action it if poss
  repeat				\ and again
  drop					\ ignore spare null $
\  bye					\ done
;

\ assign noop to-do cls			\ so we can see it all
\ assign switches to-do loader		\ first thing done

\ save t.com				\ dummy app

\ bye					\ quit to test it


