\ hooks for Xcompiler to use XShell3 services   R. G.  11/01/90 

(                                                                
The xcompiler will send values out on INT(D7)                   
                                                                
XS2 will pick these up and act on them                          
                                                                
Copyright (c) 1990                                              
MicroProcessor Engineering                                      
133 Hill Lane                                                   
Southampton SO1 5AF                                             
England                                                         
                                                                
tel: (+44) 703 631441                                           
fax: (+44) 703 339691                                           
                                                                
Last revision:  25/06/90
)

\ variables                                         \  03/02/90 
                                                                
variable api-present				\ flag off is api absent      
								\ 2:=xs2 api found, 3:= xs3 api found

\ int-d7                                        R. G.  03/02/90 

hex

asm                                                             

code int-d7             \ --;                                   
  bx push                       \ save TOS on data stack
  bp, sp xchg                   \ swap stacks                   
  0d7 int                       \ call int                      
  bp, sp xchg                   \ swap stacks                   
  bx pop                        \ restore top of stack from data stack
  next,                                                         
end-code                                                        

unhook-asm                                                      

decimal
                                                                
\ (alt-key)                                     R. G.  03/02/90 

variable key-val				\ store for found key values

: (alt-key?)			\ -- t/f ;
  (key?)  					\ is a key available
  if
    (key)					\ if so, get it
    dup 0=					\ and test with 0
    if
      drop					\ if zero, drop spare copy
      (key)					\ get next key in pair
      0 int-d7				\ do the required action
      0						\ zero flag for no key avalailable now
    else
      key-val !				\ if not zero, stash value
      -1						\ true flag for key available now
    endif
  else
    0						\ if no key, then false flag
  endif
;
                                                                
\    alt key definitions                        R. G.  12/01/90 

hex                                                             

: (alt-key)			\ -- char ;
  begin
    (alt-key?)
  until
  key-val @
;
                                                                
decimal

                                                                
\ umb-cls                                          sfp 10/01/90 
                                                                
: umb-cls               \ -- ;                                  
  1 int-d7                      \ fn# 1 = clear & top/bot bars  
;                                                               

\ umb-emit                                         sfp 10/01/90 
                                                                
: umb-emit              \ n -- ;                                
  1 out +!                      \ fix out, as if doing emit     
  2 int-d7                      \ call int D7                   
;                                                               
                                                                
\ umb-type                                         sfp 10/01/90 
                                                                
: umb-type              \ addr len -- ;                         
  dup out +!                    \ fix out, as if doing type     
  cs>                           \ segment                       
  -rot                          \ seg addr len --               
  3                             \ fn# 3 = type                  
  int-d7                        \ make call                     
;                                                               
                                                                
\ set-installed                                    sfp 10/01/90 
                                                                
hex                                                             
                                                                
: set-installed         \ -- ; sets flag                        
  0d7 get-vector					\ get seg. & off. of isr        
  3 +							\ addr of title string          
  cs> here  0A cmovel				\ move string to  here          
  here "" XShellv2" count s=			\ compare with version 2 callsign
  if 2 api-present ! endif			\ set flag                      
  here "" XShellv2/3" count s=		\ compare with version 3 callsign
  if 3 api-present ! endif			\ set flag                      
;                                                               
                                                                
\ api?                                              \  03/02/90 
                                                                
: api?                  \ -- t/f ;                              
  api-present @                 \ get flag                      
;                                                               
                                                                
\ api                                           R. G.  11/01/90 
                                                                
: api                   \ -- ;                                  
  set-installed                         \ is api present        
  api?                                  \ install if flag set   
  if                                                            
    assign (alt-key?) to-do key?	      \ new version of key?	
    assign (alt-key)  to-do key         \ pass alt-keys thru    
    assign umb-type   to-do type        \ pass type thru        
    assign umb-emit   to-do emit        \ pass emit thru        
    assign umb-cls    to-do cls         \ pass cls thru         
    cls                                 \ cls to start          
  else                                                          
    ." XShell v2/3 API not resident" cr   \ say so                
  endif                                                         
;                                                               

\ umbilical-mode                                   sfp 11/01/90 
                                                                
: umbilical-mode                \ -- ;                          
  api?                                  \ only if api resident  
  if                                                            
     4 int-d7                           \ fn#4 = change banne   
  endif                                                         
;                                                               
                                                                
\ re-open                                                       
                                                                
: scr>api       \ flag -- ; send file name to api if flag=0     
  0=  api? and                                                  
  if  cs> screen-pcb p-name             \ seg:off of file name  
      dup 03E 0 scan nip                \ find trailing 0       
      03E swap -                        \ convert to length     
      5 int-d7                          \ and pass to API       
  endif  ;                                                      
                                                                
: RE-OPEN       \ --                                            
  prev-pcb screen-pcb 040 cmove         \ copy back old name    
  screen-pcb open-path-pcb              \ open it               
  scr>api  ;                            \ pass name over        
                                                                
\ $using ................       sfp june 85         \  12/01/90 
                                                                
hex                                                             
                                                                
: $using        \ $addr -- flag ; true=fail                     
  ?exec  flush                  \ can't be compiling            
  scr-handle close-path drop    \ close current screen file     
  screen-pcb prev-pcb 040 cmove \ copy current to previous      
  screen-pcb set-pathname       \ set file name                 
  scrext                        \ add .SCR extension            
  screen-pcb open-path-pcb      \ open new path                 
  dup scr>api  ;                \ pass to API                   

\ ?make-scr                                         \  12/01/90 
                                                                
: ?make-scr                             \ flag -- ; true to make
  if  ." Can't find " .SCR                                      
      ."   Create it? " Y/N? CR                                 
      IF  screen-pcb create-path-pcb                            
          dup scr>api                   \ copy new name         
          if ." Can't create it" CR  re-open  endif             
      ELSE  RE-OPEN  ENDIF                                      
  ENDIF  ;                                                      
                                                                
\ using                                         R. G.  03/02/90 
                                                                
: using         \ -- ;                                          
  bl word $using                                                
  ?make-scr .scr cr                                             
;                                                               
                                                                
\ bl-word/uc                                       sfp 11/01/90 
                                                                
decimal                                                         
                                                                
: bl-word/uc                            \ addr                  
  bl word  dup count upper  ;           \ get text string       
                                                                
create curr-text-file 64 allot                                  
                                                                
\ $set-ext                                      R. G.  03/02/90 
decimal                                                         
                                                                
\ : $set-ext  ( ext-$adr $adr -- )                                
\            \ add extension to string if none                   
\    dup c@ >r                       \ save string length        
\    r@ 56 >                         \ no room for extension ?   
\    IF   r> drop  2drop             \ y: clear up               
\    ELSE dup   r@ 3 -  1 max   +    \ n: adr of end $ - ext     
\         r> 4 min                   \    size of end $ extension
\         ascii .  scan nip          \    dot already present ?  
\         IF    2drop                \    y: clear up            
\         ELSE  $+                   \    n: concatinate strings 
\         ENDIF                                                  
\    ENDIF                                                       
\ ;

\ use                                           R. G.  03/02/90 
                                                                
: use                   \ <file> -- ;                           
  bl-word/uc                            \ parse something       
  curr-text-file over c@ 1+ cmove       \ copy to buffer        
\  "" .FTH" curr-text-file $set-ext      \ complete name         
  api?                                  \ if api resident       
  if                                                            
     cs> curr-text-file count                                   
     6 int-d7                           \ send one to xs3       
  endif                                                         
;                                                               

