((

	EXTENS.FTH

	J Lee :- 23/1/91

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	Extensions to ModForth for compilation by any module.

))


only forth also c-c definitions
decimal




\ 2Rot 3Dup .. J Lee 25/1/91
\


decimal


Code 2Rot	( d1 d2 d3 -- d2 d3 d1 )
	bx push
	cx, bp mov				\ preserve BP
	ax, sp mov   bp, ax mov			\ set BP := SP
	bx, [bp] 8 mov   ax, [bp] 10 mov	\ grab d1
	ax push   bx push			\ push d1
	bx, [bp] 4 mov   ax, [bp] 6 mov		\ grab d2
	8 [bp], bx mov   10 [bp], ax mov	\ shuffle down d2
	bx, [bp] 0 mov   ax, [bp] 2 mov		\ grab d3
	4 [bp], bx mov   6 [bp], ax mov		\ shuffle d3
	bx pop   ax pop				\ pop d1
	0 [bp], bx mov   2 [bp], ax mov		\ rewrite d1
	bp, cx mov				\ restore BP
	bx pop
	next,
End-Code


Code 3Dup	( n1 n2 n3 -- n1 n2 n3 n1 n2 n3 )
\	bx pop
	ax pop   cx pop
	cx push   ax push   bx push
	cx push   ax push
\	bx push
	next,
End-Code




\ Count-L Type-L S=L .. J Lee -- 23/1/91
\


: Count-L  ( seg off -- seg' off' len )
  2dup c@l  swap 1+ swap  ;


: Type-L  ( seg off len -- )
  0
  ?Do
    2dup c@l emit  1+
  Loop
  2drop  ;


Code S=l  ( seg addr1 seg addr2 count -- t/f )
  cx, bx mov   L$3 jcxz

  bp, sp xchg  ds push  es push  bp, sp xchg
  bx, si mov   si pop  ds pop
  dx, di mov   di pop  es pop
  repz cmpsb
  si, bx mov   di, dx mov
  bp, sp xchg  es pop  ds pop  bp, sp xchg
  L$2 jnz

L$1:
  bx, # -1 mov   next,

L$2:
  bx, bx sub   next,

L$3:
  sp, # 8 add   L$1 jmp
End-Code




\ .Hex .. J Lee -- 27/07/90
\

: .hex
	base @  hex
	swap 0 <# # # # # #> type
	base !  ;




\ ?File-Size .. J Lee -- 27/07/90
\


hex

\ This word assumes that the file is already open
\
Code ?File-Size	(( pcb -- #bytes(d) ; returns 32-bit file size ))
	bx, [bx] 0 mov					\ get file handle (must be open)
	ax, # 04201 mov				\ get current file pointer pos.
	dx, dx sub   cx, cx sub			\ 0 offset from curr. pos.
	021 int						\ 
	nc, if,						\ exit on error
		bp, sp xchg			
		dx push   ax push			\ preserve curr. pos.
		bp, sp xchg
		ax, # 04202 mov		 	\ move to end of file
		dx, dx sub   cx, cx sub	 	\ 0 offset i.e. file size
		021 int			   	 	\ 
		nc, if,			   	 	\ exit on error
			ax push   dx push  	 	\ push file size
			ax, # 04200 mov   	 	\ reposition file pointer
			bp, sp xchg
			dx pop   cx pop   	 	\ get preserved file position
			bp, sp xchg
			021 int		   	 	\ 
			bx pop			 	\ restore TOS
			next,
		endif,
		bp, sp xchg
		ax pop   dx pop	   	  	\ remove preserved file pos.
		bp, sp xchg
	endif,
	bx pop			   		  	\ reset TOS
	next,
End-Code
		



\ UWithin? .. J Lee -- 20/09/90
\


Code UWithin?	( n low high -- t/f )
	ax pop   dx pop
	dx, ax cmp
	l$1 jb
	dx, bx cmp
	l$1 ja
	bx, # -1 mov
	next,

l$1:
	bx, bx sub
	next,
End-Code




\ #Bytes>#Paras .. J Lee -- 19/2/91
\


decimal

: #Bytes>#Paras  ( #bytes -- #paras ; conversion )
  0                \ make positive double
  16, d+           \ force at least one paragraph
  16 um/mod nip  ; \ divide by bytes / paragraph
 



\ Fill(s)l .. J Lee -- 02/07/90
\


Code Fill(s)l		( seg offset len b -- )
	al, bl mov		\ save byte
	dx, di mov   cx pop   di pop
	l$1 jcxz
	es pop
	rep stosb

l$1:
	di, dx mov
	bx pop
	next,
End-Code




\ Get-Vector
\

code get-vector                         \ n -- seg offset
  cx, es mov                            \ save segment reg
  ax, bx mov   ah, # $35 mov   $21 int  \ call dos
  es push   es, cx mov                  \ return data, res. seg.
  next,   end-code                      \ all done


code set-vector                         \ seg offset n --
  ax, bx mov                            \ get vector number
  ah, # $25 mov   bx, ds mov            \ set function, save seg
  dx pop   ds pop   $21 int             \ set addr & call dos
  ds, bx mov   bx pop   next,  end-code \ restore ds, exit



